//
// jot - Text Editor for Windows Mobile
//   Copyright (C) 2007-2008, Aquamarine Networks.  <http://pandora.sblo.jp/>
//
//    This program is EveryOne's ware; you can redistribute it and/or modify it 
//    under the terms of the NYSL version 0.9982 or later. <http://www.kmonos.net/nysl/>
//

#include "stdafx.h"

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <tchar.h>

#include "imecomp.h"

#define BUFFERSIZE				30

typedef struct {
	// ێĂe
	BYTE	m_bComAttr[BUFFERSIZE+1];	// ̑
	DWORD	m_dwCompCls[BUFFERSIZE+1];	// R|WV
	TCHAR	m_szComStr[BUFFERSIZE+1];	// ̃obt@
	int		m_nComSize;					// TCY
	int		m_nComCursorPos;			// ɂ錻݂̃J[\ʒu
	DWORD	m_nComAttrSize;				// ̑̃TCY
	POINT	m_CandPos;					// ⑋̏ꏊ

	HFONT	m_hFont;
}	COMPBUF;

static	void	DrawString( HDC hdc , TCHAR *str,int len ,HFONT hfont, RECT *prect , bool bDraw=true , bool reverse=false) 
{
	if ( reverse ){
		// ]
		SetTextColor(hdc, GetSysColor(COLOR_HIGHLIGHTTEXT));
		SetBkColor(hdc, GetSysColor(COLOR_HIGHLIGHT));
	}else{
		// ʏ
		SetTextColor(hdc, GetSysColor(COLOR_WINDOWTEXT));
		SetBkColor(hdc, GetSysColor(COLOR_WINDOW));
	}
	
	HGDIOBJ hObj = SelectObject( hdc , hfont );

	UINT flags = DT_NOPREFIX|DT_LEFT|DT_TOP|DT_SINGLELINE;

	if ( !bDraw ){
		flags |= DT_CALCRECT;
	}
	DrawText(hdc, str , len , prect , flags );

	SelectObject( hdc , hObj );
}


/*
 * imecomp_proc - IME R|WVEBhEvV[W
 */
static LRESULT CALLBACK imecomp_proc(const HWND hWnd, const UINT msg, const WPARAM wParam, const LPARAM lParam)
{
	COMPBUF *bf;

	switch (msg) {
	case WM_CREATE:
		if ((bf = new COMPBUF) == NULL) {
			return -1;
		}
		// buffer info to window long
		SetWindowLong(hWnd, GWL_USERDATA, (LPARAM)bf);

		// obt@̏
		ZeroMemory( &bf->m_bComAttr , sizeof(BYTE)*(BUFFERSIZE+1) );
		ZeroMemory( &bf->m_dwCompCls ,sizeof(DWORD)*(BUFFERSIZE+1) );
		ZeroMemory( &bf->m_szComStr , sizeof(TCHAR)*(BUFFERSIZE+1) );

		bf->m_hFont = NULL;
		break;

	case WM_DESTROY:
		if ((bf = (COMPBUF *)GetWindowLong(hWnd, GWL_USERDATA)) != NULL) {
			SetWindowLong(hWnd, GWL_USERDATA, (LPARAM)0);

			delete bf;
		}
		return DefWindowProc(hWnd, msg, wParam, lParam);

	case WM_PAINT:
		if ((bf = (COMPBUF *)GetWindowLong(hWnd, GWL_USERDATA)) != NULL) {
			RECT rect;
			GetClientRect( hWnd , &rect );

			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hWnd, &ps);

			// ϊ߂̉̕\
			int	nXStart = 0;
			for (int i = 0; ; i++){
				RECT drect = rect;
				DWORD CurrCls = bf->m_dwCompCls[i];
				DWORD NextCls = bf->m_dwCompCls[i+1];
				DWORD ClsLen  = NextCls - CurrCls;

				if ( ClsLen == 0 ){
					ClsLen = -1 ;
				}

				if (CurrCls == bf->m_nComAttrSize)
					break;

				drect.left = nXStart;

				DrawString( hdc , &bf->m_szComStr[CurrCls] ,ClsLen ,
					bf->m_hFont, &drect , false);


				int nXEnd = drect.right;
				
				HPEN	hPen;
				bool	reverse = false;
				switch(bf->m_bComAttr[CurrCls]){
				case 0x00:
					// ͕̏ꍇ
					hPen = ::CreatePen( PS_DASH, 1, GetSysColor(COLOR_WINDOWTEXT));
					break;
				case 0x01:
					// ҏW\Ȍ̏ꍇ
					hPen = ::CreatePen( PS_DASH, 1, GetSysColor(COLOR_WINDOWTEXT));
					bf->m_CandPos.x = nXStart;
					bf->m_CandPos.y = drect.bottom+1;
					reverse = true;
					break;
				default:
					// ϊꂽ̏ꍇ
					hPen = ::CreatePen( PS_SOLID, 1, GetSysColor(COLOR_WINDOWTEXT));
					break;
				}
				DrawString( hdc , &bf->m_szComStr[CurrCls] ,ClsLen ,
					bf->m_hFont, &drect , true , reverse);

				HGDIOBJ	pOldPen = SelectObject(hdc , hPen);
				MoveToEx(hdc , nXStart + 1, drect.bottom-1 , NULL);
				LineTo(hdc , nXEnd   - 1, drect.bottom-1);
				SelectObject(hdc , pOldPen);
				DeleteObject( hPen );

				nXStart = nXEnd;

				if (CurrCls == NextCls)
					break;
			}

			// J[\ʒu̕\
			{
				RECT drect = rect;
				int cursor = bf->m_nComCursorPos;
				DrawString( hdc , &bf->m_szComStr[0] ,cursor ,
					bf->m_hFont, &drect , false);

				HPEN	hPen;
				hPen = ::CreatePen( PS_SOLID, 1, GetSysColor(COLOR_WINDOWTEXT));

				HGDIOBJ	pOldPen = SelectObject(hdc , hPen);
				MoveToEx(hdc , drect.right-1 , drect.top , NULL);
				LineTo(hdc , drect.right-1, drect.bottom );
				SelectObject(hdc , pOldPen);
				DeleteObject( hPen );
			}
			EndPaint(hWnd, &ps);
		}
		break;



	case WM_IMECOMP_COPMSTR:
		// R|WVCxg
		if ((bf = (COMPBUF *)GetWindowLong(hWnd, GWL_USERDATA)) != NULL ) {
			if (lParam & GCS_COMPSTR) {
				HIMC	hIMC = (HIMC)(wParam);
				RECT rect;
				// EBhETCYOŏ
				rect.top = rect.left = rect.right = rect.bottom = 0;

				// 擾܂
				bf->m_nComSize = ImmGetCompositionString(hIMC, GCS_COMPSTR, (LPVOID)bf->m_szComStr, sizeof(TCHAR) * (BUFFERSIZE));

				// f[^肩G[ȂAȂ΃f[^擾
				if (  bf->m_nComSize != IMM_ERROR_NODATA && bf->m_nComSize != IMM_ERROR_GENERAL){

					bf->m_szComStr[bf->m_nComSize/2]=_T('\0');

					// ł̕уJ[\ʒu擾܂
					if (lParam & GCS_COMPATTR)
						bf->m_nComAttrSize = ImmGetCompositionString(hIMC, GCS_COMPATTR, bf->m_bComAttr, sizeof(bf->m_bComAttr));

					if (lParam & GCS_CURSORPOS)
						bf->m_nComCursorPos = ImmGetCompositionString(hIMC, GCS_CURSORPOS, NULL, 0);

					if (lParam & GCS_COMPCLAUSE)
						ImmGetCompositionString(hIMC, GCS_COMPCLAUSE, bf->m_dwCompCls,sizeof(bf->m_dwCompCls));

					GetClientRect( hWnd , &rect );
					HDC	hdc = GetDC(hWnd);
					DrawString( hdc , bf->m_szComStr,-1,bf->m_hFont, &rect , false);
					ReleaseDC(hWnd, hdc);
				}

				SetWindowPos( hWnd , NULL , 0,0, rect.right,rect.bottom, SWP_NOMOVE|SWP_NOZORDER );
				InvalidateRect( hWnd , &rect , FALSE );
			}
		}
		break;
	case WM_IMECOMP_ENDCOMP:
		if ((bf = (COMPBUF *)GetWindowLong(hWnd, GWL_USERDATA)) != NULL ) {
			bf->m_szComStr[0] = _T('\0');
			bf->m_nComSize = 0;
			SetWindowPos( hWnd , NULL , 0,0, 0,0, SWP_NOMOVE|SWP_NOZORDER );
			return TRUE;
		}
		break;

	case WM_IMECOMP_GETCANDPOS:
		if ((bf = (COMPBUF *)GetWindowLong(hWnd, GWL_USERDATA)) != NULL ) {
			return MAKELONG( bf->m_CandPos.x ,bf->m_CandPos.y  );
		}
		break;

	case WM_SETFONT:
		// tHgݒ
		if ((bf = (COMPBUF *)GetWindowLong(hWnd, GWL_USERDATA)) != NULL) {
			bf->m_hFont = (HFONT) wParam;
		}
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}

/*
 * imecomp_regist - NX̓o^
 */
BOOL imecomp_regist(const HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style = CS_DBLCLKS|CS_IME;
	wc.lpfnWndProc = (WNDPROC)imecomp_proc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(0, IDC_IBEAM);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.lpszMenuName = 0;
	wc.lpszClassName = IMECOMP_WND_CLASS;
	return RegisterClass(&wc);
}

